var itemid;
var unlockCount;
var totalCount;
var idx;

var correctAnswer;
var questionList = [];
var answerList = ['A', 'B', 'C', 'D'];
var updateProgressFlag = false;

apiready=function(){
	itemid = api.pageParam.itemid;
    unlockCount = api.pageParam.unlockCount;
    totalCount = api.pageParam.totalCount;
    idx = api.pageParam.idx;

    api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
        quit();
	});
    api.showProgress({
        title: '加载中...',
        text: ''
    });

    getQuestionList();
    setProgress(unlockCount);
    getExamDate(itemid);
}

function getQuestionList() {
    api.ajax({
        url : examURL + 'item_zxlm/966',
        method : 'post',
        cache : false,
        timeout : 30,
        dataType : 'json',
        data : {},
        returnAll : false,
    }, function(ret, err) {
        // console.log(JSON.stringify(ret,null,4));
        if(ret){
            questionList = ret;
            api.hideProgress();
        }
    });
}

function setProgress(count) {
    // 进度条
    var l_ = $(".hdcg_count_outside").offset().left;
    var outside_w = $('.hdcg_count_outside').width();
	var progress_w = count / totalCount;
    // 闯关数
    var spanHtml = '当前闯关成功关数：' + count + '/' + totalCount;

    $api.css($api.dom(".hdcg_count_progress"),"left:" + (l_ + api.winWidth * 0.05) + "px;width:" + outside_w * progress_w + "px");
    $api.css($api.dom(".hdcg_count>span"),"left:" + (l_ + api.winWidth * 0.05) + "px;width:" + outside_w + "px;line-height:" + api.winHeight * 0.115 + "px");
    $api.html($api.dom(".hdcg_count>span"), spanHtml);
}

function getExamDate(examid) {
    api.ajax({
		url : examURL + 'question/' + examid + '/' + 1,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		// console.log(JSON.stringify(ret,null,4));
		if(ret){
            var res = ret.result[0];
            correctAnswer = res.answer;
            var html = '';
            html += '<p>' + res.content + '</p>'
            html += '<p>' + res.choiceA + '</p>'
            html += '<p>' + res.choiceB + '</p>'
            html += '<p>' + res.choiceC + '</p>'
            html += '<p>' + res.choiceD + '</p>'
            html += '<ul class="options">'
                for (let i = 0; i < answerList.length; i++) {
                    html += '<li onclick="answer(' + i + ')">'
                        html += '<img src="../../image/pages/hdcg/' + answerList[i] + '.png" />'
                        html += '<img src="../../image/pages/hdcg/' + answerList[i] + '1.png" />'
                    html += '</li>'
                }
            html += '</ul>'

            $api.html($api.dom('.hdcg_body>span'), '第' + (idx + 1) + '关');
            $api.html($api.dom('.hdcg_question'), html);
		}
	})
}

function answer(index) {
    var dom = $api.domAll($api.dom('.options'), 'li');
	for (var i = 0; i < dom.length; i++) {
		if (i == index) {
			$api.addCls(dom[i], 'active');
		} else {
			$api.removeCls(dom[i], 'active');
		}
	}
    var html = '';
    if (answerList[index] == correctAnswer) {
        idx += 1;
        if (idx > unlockCount) {
            updateProgress();
        }
        if (idx >= questionList.length) {
            html += '<img src="../../image/pages/hdcg/finish.png" />'
            html += '<div class="btns">'
                html += '<img onclick="quit()" src="../../image/pages/hdcg/quit.png" />'
            html += '</div>'
        } else {
            html += '<img src="../../image/pages/hdcg/success.png" />'
            html += '<div class="btns">'
                html += '<img onclick="quit()" src="../../image/pages/hdcg/quit.png" />'
                html += '<img onclick="next()" src="../../image/pages/hdcg/next.png" />'
            html += '</div>'
        }
    } else {
        html += '<img src="../../image/pages/hdcg/fail.png" />'
        html += '<div class="btns">'
            html += '<img onclick="quit()" src="../../image/pages/hdcg/quit.png" />'
            html += '<img onclick="again()" src="../../image/pages/hdcg/again.png" />'
        html += '</div>'
    }

    $api.html($api.dom('.hdcg_dialog'), html);
    $api.css($api.dom(".hdcg_dialog"),"z-index:10");
}

function updateProgress() {
    api.ajax({
        url : userURL + 'updateUserCGScore',
        method : 'post',
        cache : false,
        timeout : 30,
        dataType : 'json',
        data : {
            values : {
                score : 0,
                guanqia : idx
            }
        },
        returnAll : false,
    }, function(ret, err) {
        // console.log(JSON.stringify(ret,null,4));
        if(ret && ret.code == '0000'){
            updateProgressFlag = true;
        }
    });
}

function next() {
    $api.css($api.dom(".hdcg_dialog"),"z-index:-10");
    if (idx > unlockCount) {
        unlockCount += 1;
        setProgress(unlockCount);
    }
    getExamDate(questionList[idx].id);
}

function again() {
    $api.css($api.dom(".hdcg_dialog"),"z-index:-10");
    var dom = $api.domAll($api.dom('.options'), 'li');
	for (var i = 0; i < dom.length; i++) {
		$api.removeCls(dom[i], 'active');
	}
}

function quit() {
    if (updateProgressFlag) {
        api.execScript({
            name:"root",
            script: "hdcg();"
        });
    }
    backWin();
}